#!/bin/bash

#
# STARCRAFT OUTGOING NAT RULES
#

# MY IP ADDRESS IS
ME=$(/sbin/ifconfig | grep "inet addr" | awk -F: '{print $2}' | awk '{print $1}'|sed -n 1p)

# OUR NETWORK IS...(Assumes a 255.255.255.0 network/netmask)
NETWORK=192.168.1

# Last Digits of our StarCraft PC IP Addresses
# We'll be doing $NETWORK.$PC
PC1=77
PC2=19
PC3=50
PC4=55
LAN="$PC1 $PC2 $PC3 $PC4"
case "$1" in
   start)
     iptables -t nat -N SC-OUT
     iptables -t nat -I POSTROUTING -p udp -s ${NETWORK}.0/24 --sport 6112 --dport 6112 -j SC-OUT
     iptables -t nat -I POSTROUTING -p tcp -s ${NETWORK}.0/24 --sport 6112 --dport 6112 -j SC-OUT
     for i in $LAN
       do
         iptables -t nat -I SC-OUT -p udp -s ${NETWORK}.$i --sport 6112 --dport 6112 -j SNAT --to $ME:600$i
         iptables -t nat -I SC-OUT -p tcp -s ${NETWORK}.$i --sport 6112 --dport 6112 -j SNAT --to $ME:600$i
     done

#
# STARCRAFT INCOMING NAT RULES
#
     iptables -t nat -N SC-IN
     iptables -t nat -I PREROUTING -p udp -m multiport --dports 600${PC1},600${PC2},600${PC3},600${PC4} -j SC-IN
     iptables -t nat -I PREROUTING -p tcp -m multiport --dports 600${PC1},600${PC2},600${PC3},600${PC4} -j SC-IN
     for i in $LAN
       do
         iptables -t nat -I SC-IN -p udp -d $ME --dport 600$i -j DNAT --to ${NETWORK}.${i}:6112
         iptables -t nat -I SC-IN -p tcp -d $ME --dport 600$i -j DNAT --to ${NETWORK}.${i}:6112
     done
	iptables -A FORWARD -p udp --sport 6112 -j ACCEPT
	echo 0 > /proc/sys/net/ipv4/conf/eth0/rp_filter

     ;;

   stop)
     iptables -t nat -F SC-OUT || exit 0
     iptables -t nat -F SC-IN || exit 0
     iptables -t nat -D POSTROUTING -p udp -s ${NETWORK}.0/24 --sport 6112 --dport 6112 -j SC-OUT
     iptables -t nat -D POSTROUTING -p tcp -s ${NETWORK}.0/24 --sport 6112 --dport 6112 -j SC-OUT
     iptables -t nat -D PREROUTING -p udp -m multiport --dports 600${PC1},600${PC2},600${PC3},600${PC4} -j SC-IN
     iptables -t nat -D PREROUTING -p tcp -m multiport --dports 600${PC1},600${PC2},600${PC3},600${PC4} -j SC-IN
     iptables -t nat -X SC-OUT
     iptables -t nat -X SC-IN
     ;;
   *)
     echo "Usage $0 {start|stop}"
     ;;
esac
